<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: manual.php,v 1.12 2000/10/04 17:54:45 asun Exp $

include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-swupdate", "/base/swupdate/manualHandler.php");

// get all loaded packages. we'll match anything that's a tar
// file
$dirName = "/home/packages";
$magic_cmd = "/usr/bin/file";
$packages = array();
if(is_dir($dirName)) {
  $dir = opendir($dirName);
  while($file = readdir($dir)) {
	if ($file[0] == '.')
		continue;
	$serverScriptHelper->shell("$magic_cmd $dirName/$file", $output);
	if (ereg("(tar|compressed|PGP\s+armored|\sdata$)", $output)) {
		$packages[] = $file;
	}
  }
  closedir($dir);
}

$page = $factory->getPage();

$block = $factory->getPagedBlock("manualInstall");

$location = $factory->getMultiChoice("locationField");
$url = $factory->getOption("url", true);
$url->addFormField($factory->getUrl("urlField"));
$location->addOption($url);
$upload = $factory->getOption("upload");
$upload->addFormField($factory->getFileUpload("fileField"));
$location->addOption($upload);

// add packages as an option if there are packages
if(count($packages) > 0) {
  $loaded = $factory->getOption("loaded");
  $loaded->addFormField($factory->getMultiChoice("loadedField", $packages));
  $location->addOption($loaded);
}

$block->addFormField(
  $location,
  $factory->getLabel("locationFieldEnter")
);

$block->addFormField($factory->getTextField("backUrl", $backUrl, ""));
$block->addButton($factory->getButton($page->getSubmitAction(), "prepare"));
$block->addButton($factory->getCancelButton($backUrl));

$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>
<?php print($block->toHtml()); ?>
<?php print($page->toFooterHtml()); ?>
